; tabstop=8
;
;
	ORG	0E000H

	JP	INTMASK
	JP	INIT8251
	JP	TXDATA
	JP	RXDATA
	JP	RXQUICK

MODE8251:
	DB	4FH		; stop=1/parity=none/length=8bit/clock=x64
DTSTART:
	DW	0000H
DTSIZE:
	DW	4000H
TXMODE:
	DB	85H		; DSR=on/TxEMPTY=1/TxRDY=1
RXMODE:
	DB	82H		; DSR=on/RxRDY=1

INTMASK:
	DI
	LD	A,73H
	LD	(0FA04H),A	; RS232C̊荞݂XLbv
	EI
	RET

INIT8251:
	DI
	LD	A,(MODE8251)
	LD	B,A
	LD	A,12H
	OUT	(81H),A		; RTS=off/DTR=on/Tx=Disable/Rx=Disable/Error clear
	LD	A,52H
	OUT	(81H),A		; 8251 Reset
	NOP			; wait
	NOP
	NOP
	NOP
	LD	A,B
	OUT	(81H),A		; 8251 mode set
	LD	A,37H
	OUT	(81H),A		; RTS=on/DTR=on/Tx=Enable/Rx=Ensable/Error clear
	EI
	RET

TXDATA:
	DI
	LD	HL,(DTSTART)
	LD	BC,(DTSIZE)
	LD	A,(TXMODE)
	LD	D,A
TX_L1:
	IN	A,(81H)
	AND	D
	CP	D
	JR	NZ,TX_L1
	LD	A,(HL)
	OUT	(80H),A
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,TX_L1
	EI
	RET

RXDATA:
	DI
	LD	HL,(DTSTART)
	LD	BC,(DTSIZE)
	LD	A,(RXMODE)
	LD	D,A
RX_L2:
	LD	A,37H
	OUT	(81H),A		; RTS=on
RX_L1:
	IN	A,(81H)
	AND	D
	CP	D
	JR	NZ,RX_L1
	LD	A,17H
	OUT	(81H),A		; RTS=off
	IN	A,(80H)
	LD	(HL),A
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,RX_L2
	LD	A,37H
	OUT	(81H),A		; RTS=on
	EI
	RET

RXQUICK:
	DI
	LD	A,02H
	OUT	(93H),A
	LD	HL,(DTSTART)
	LD	BC,(DTSIZE)
	LD	D,02H
	LD	E,B
	LD	B,C
	LD	C,80H
	LD	A,37H
	OUT	(81H),A		; RTS=on
RQ_L1:
	IN	A,(81H)		; 11+1
	AND	D		; 4+1
	JP	Z,RQ_L1		; 10+1
				; 28

	INI			; 16+2
	JR	NZ,RQ_L1	; 7+1  / 12+1
	DEC	E		; 4+1
	JP	NZ,RQ_L1	; 10+1
				; 42

	LD	A,37H
	OUT	(81H),A		; RTS=on

	LD	A,03H
	OUT	(93H),A
	EI
	RET


